// Ranish ZeroServ 1.8 Sept 08, 2003 * Created by Mikhail Ranish
// Compileable with VC++ or BCC 5.55 * http://www.ranish.com/zeroserv/
// Distributed under http://www.creativecommons.org/licenses/by-sa/1.0/

#define Z_VERSION "1.8"

#define WIN32_LEAN_AND_MEAN

#define MAX_THR 100
#define MAX_CFG 300

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <direct.h>
#include <windows.h>
#include <windowsx.h>
#include <winsock2.h>
#include <shellapi.h>

HMENU hMenu;
NOTIFYICONDATA nidIcon;
int debug=-1, nowin=0, BkNReq=0, NReq=0, timer;
#define NURL 24
#define LENURL 1024
int  nurl=0;
char turl[NURL][2*LENURL];

FILE *log;
FILE *chklog(void)
{
 if( debug && log==0 && (log=fopen("ZeroServ.log","a"))!=0 ) setbuf(log,NULL);
 else if( debug==0 && log ) { FILE *l2=log; log=0; Sleep(1); fclose(l2); }
 return log;
}


LRESULT APIENTRY MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
DWORD  WINAPI ZeroServ(LPVOID p);


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
 int     i;
 MSG     msg;
 HWND    hwnd;
 WSADATA wsaData;

 for( i=0 ; lpCmdLine[i]!=0 ; )
       if( strncmp(lpCmdLine+i,"-nowin",6)==0 ) {i+=6; nowin=1;}
  else if( strncmp(lpCmdLine+i,"-debug",6)==0 ) {i+=6; debug=atoi(lpCmdLine+i);}
  else i++;

 chklog();
 
 if( WSAStartup(0x202,&wsaData)==SOCKET_ERROR )
   {
    if(debug&&log)fprintf(log,"ZeroServ: Error calling WSASturtup(0x202). Exiting...\n");
    exit(1);
   }

 strcpy(turl[9],"        ZeroServ is a Tiny Web Server designed to block Banner Ads and Popups");
 strcpy(turl[8],"        ZeroServ is an Open Source Freeware by Mikhail Ranish (www.ranish.com)");
 strcpy(turl[2]," [ THIS SOFTWARE COMES WITH NO WARRANTIES! USE AT YOUR OWN RISK! STUDY SOURCE CODE! ]");

 ZeroServ(0);

 if( nowin )
  while(1)
   Sleep(1000);

 if( !hPrevInstance )
   {
    WNDCLASS  wc;

    wc.style = 0;
    wc.lpfnWndProc = (WNDPROC)MainWndProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "ZEROICON");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (struct HBRUSH__*)GetStockObject(LTGRAY_BRUSH);
    wc.lpszMenuName =  NULL;//"ZeroServMenu";
    wc.lpszClassName = "ZeroServ";
    if (!RegisterClass(&wc)) return (FALSE);
   }

 hwnd = CreateWindow(
        "ZeroServ",
        "ZeroServ " Z_VERSION,
        WS_BORDER | WS_SYSMENU | WS_SIZEBOX | WS_MINIMIZEBOX,
        CW_USEDEFAULT,
        CW_USEDEFAULT,
        780,
        36+NURL*16,
        NULL,
        NULL,
        hInstance,
        NULL);

    hMenu=CreatePopupMenu();
    AppendMenu(hMenu,MF_STRING,1,"http://www.ranish.com/");
    AppendMenu(hMenu,MF_SEPARATOR,0,0);
    AppendMenu(hMenu,MF_STRING,2,"Configuring IE");
    AppendMenu(hMenu,MF_STRING,3,"Configuring Opera");
    AppendMenu(hMenu,MF_STRING,4,"Configuring Netscpe");
    AppendMenu(hMenu,MF_SEPARATOR,0,0);
    AppendMenu(hMenu,MF_STRING,5,"Debug level++");
    AppendMenu(hMenu,MF_STRING,6,"Debug level Off");
    AppendMenu(hMenu,MF_SEPARATOR,0,0);
    AppendMenu(hMenu,MF_STRING,7,"Edit ZeroServ.ini");
    AppendMenu(hMenu,MF_SEPARATOR,0,0);
    AppendMenu(hMenu,MF_STRING,8,"Reload ZeroServ.ini");
    AppendMenu(hMenu,MF_SEPARATOR,0,0);
    AppendMenu(hMenu,MF_STRING,9,"Exit");

    nidIcon.cbSize=sizeof(NOTIFYICONDATA);
    nidIcon.hWnd=hwnd;
    nidIcon.hIcon=LoadIcon(hInstance,"ZEROICON");
    strcpy(nidIcon.szTip,"ZeroServ " Z_VERSION );
    nidIcon.uID=1;
    nidIcon.uCallbackMessage=WM_USER+1;
    nidIcon.uFlags=NIF_ICON+NIF_TIP+NIF_MESSAGE;
    Shell_NotifyIcon(NIM_ADD,&nidIcon);


 while( GetMessage(&msg,NULL,0,0) )
    {
     TranslateMessage(&msg);
     DispatchMessage(&msg);
    }

 return (msg.wParam);
}

static HFONT font=NULL;


LRESULT APIENTRY MainWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 POINT pt;
 
 if( message==WM_USER+1 &&lParam==WM_RBUTTONDOWN )
   {
    GetCursorPos(&pt);
    SetForegroundWindow(hwnd);
    TrackPopupMenu(hMenu,TPM_BOTTOMALIGN|TPM_LEFTBUTTON|TPM_RIGHTBUTTON,pt.x,pt.y,0,hwnd,NULL);
    PostMessage(hwnd,WM_NULL,0,0);
   }
 else if( message==WM_COMMAND && wParam==5 )
        { debug++;sprintf(turl[nurl=(nurl+1)%NURL],"Debug level set to %d",debug);BkNReq=-1;chklog();}
 else if( message==WM_COMMAND && wParam==6 )
        { debug=0;sprintf(turl[nurl=(nurl+1)%NURL],"Debug level set to %d",debug);BkNReq=-1;chklog();}
 else if( message==WM_COMMAND && wParam>0 && wParam<8 )
   {
    char *p;
    if( wParam==1 ) p="http://www.ranish.com/";
    if( wParam==2 ) p="http://www.ranish.com/zeroserv/";//config_ie.htm";
    if( wParam==3 ) p="http://www.ranish.com/zeroserv/";//config_op.htm";
    if( wParam==4 ) p="http://www.ranish.com/zeroserv/";//config_nn.htm";
    if( wParam==7 ) p="ZeroServ.ini";
    ShellExecute(hwnd, NULL, p, NULL, "", SW_SHOW);
   }
 else if( message==WM_COMMAND && wParam==8 ) // Reload config
   {
    ZeroServ(0);
   }
 else if( message==WM_COMMAND && wParam==9 )
   {
    Shell_NotifyIcon(NIM_DELETE,&nidIcon);
    exit(0);
   }
 else if( message==WM_USER+1 && lParam==WM_LBUTTONDBLCLK )
   {
    SetForegroundWindow(hwnd);
    ShowWindow(hwnd, SW_RESTORE);
    timer=SetTimer(hwnd,0,500,0);
   }
 else if( message==WM_SYSCOMMAND && wParam==SC_CLOSE )
   {
    KillTimer(hwnd,timer);
    ShowWindow(hwnd, SW_HIDE);
    return TRUE;
   }
 else if( message==WM_TIMER && BkNReq!=NReq)
   {
    RECT r;
    GetClientRect(hwnd, &r); // Obtain the window's client rectangle 
    InvalidateRect(hwnd,&r,1);
    BkNReq=NReq;
    if(NReq)
      {
       char txt[128];
       sprintf(txt," %d requests were handled by ZeroServ " Z_VERSION,NReq);
       SetWindowText(hwnd,txt);
      }
   }
 else if( message==WM_PAINT )
   {
    int i,n;
    HDC dc;
    RECT r;
    PAINTSTRUCT pts;
    char txt[512], *p, *q;

    dc=BeginPaint(hwnd,&pts);
    GetClientRect(hwnd,&r); // Obtain the window's client rectangle 
    if( font==NULL )
	font=CreateFont(16,0,0,0,0,0,0,0,ANSI_CHARSET,0,0,0,0,"Arial");
    if( font==NULL )
        font=(struct HFONT__*)GetStockObject(ANSI_FIXED_FONT); 
    /*oldfont=(HFONT)*/SelectObject(dc,font);
    SetTextColor(dc,RGB(0,0,0));
    n=nurl;
    for(i=0;i<NURL;i++)
       {
        int c=255, k, j=(NURL+n-i)%NURL;
        if( (j%4)>1 && turl[j][0] ) c=230;
        SetBkColor(dc,RGB(c,255,c));
        //sprintf(txt,"%-*s",LENURL,turl[j]);
        for(k=0,p=turl[j],q=txt;k<255;k++,q++){*q=(*p?*p++:' ');}*q=0;
        TextOut(dc,1,3+i*16,txt,strlen(txt));
       }
    //SelectObject(hdc,oldfont);
    EndPaint(hwnd,&pts);
   }
 else if( message==WM_DESTROY )
   {
    Shell_NotifyIcon(NIM_DELETE,&nidIcon);
    PostQuitMessage(0);
   }

 return (DefWindowProc(hwnd,message,wParam,lParam));
}

unsigned
char gif01x01[42]={//to make transparent set byte[39] 0x44->0x4C   R    G    B
0x47,0x49,0x46,0x38,0x39,0x61,0x01,0x00,0x01,0x00,0x80,0x00,0x00,0xFC,0xFF,0xE1,
0xFF,0xFF,0xFF,0x21,0xF9,0x04,0x01,0x00,0x00,0x01,0x00,0x2C,0x00,0x00,0x00,0x00,
0x01,0x00,0x01,0x00,0x00,0x02,0x01,0x44,0x00,0x3B};

unsigned
char gif20x20[58]={//to make transparent set byte[39] 0x84->0x8C   R    G    B
0x47,0x49,0x46,0x38,0x39,0x61,0x14,0x00,0x14,0x00,0x80,0x00,0x00,0xFF,0xFF,0xDD,
0xFF,0xFF,0xFF,0x21,0xF9,0x04,0x01,0x00,0x00,0x01,0x00,0x2C,0x00,0x00,0x00,0x00,
0x14,0x00,0x14,0x00,0x00,0x02,0x11,0x84,0x8F,0xA9,0xCB,0xED,0x0F,0xA3,0x9C,0xB4,
0xDA,0x8B,0xB3,0xDE,0xBC,0xFB,0xAF,0x15,0x00,0x3B};

unsigned
char jpg20x20[525]={
0xFF,0xD8,0xFF,0xE0,0x00,0x10,0x4A,0x46,0x49,0x46,0x00,0x01,0x01,0x01,0x00,0x64,
0x00,0x64,0x00,0x00,0xFF,0xDB,0x00,0x43,0x00,0x10,0x0B,0x0C,0x0E,0x0C,0x0A,0x10,
0x0E,0x0D,0x0E,0x12,0x11,0x10,0x13,0x18,0x28,0x1A,0x18,0x16,0x16,0x18,0x31,0x23,
0x25,0x1D,0x28,0x3A,0x33,0x3D,0x3C,0x39,0x33,0x38,0x37,0x40,0x48,0x5C,0x4E,0x40,
0x44,0x57,0x45,0x37,0x38,0x50,0x6D,0x51,0x57,0x5F,0x62,0x67,0x68,0x67,0x3E,0x4D,
0x71,0x79,0x70,0x64,0x78,0x5C,0x65,0x67,0x63,0xFF,0xDB,0x00,0x43,0x01,0x11,0x12,
0x12,0x18,0x15,0x18,0x2F,0x1A,0x1A,0x2F,0x63,0x42,0x38,0x42,0x63,0x63,0x63,0x63,
0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,
0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,
0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0x63,0xFF,0xC2,
0x00,0x11,0x08,0x00,0x14,0x00,0x14,0x03,0x01,0x22,0x00,0x02,0x11,0x01,0x03,0x11,
0x01,0xFF,0xC4,0x00,0x15,0x00,0x01,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x05,0xFF,0xC4,0x00,0x15,0x01,0x01,0x01,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x03,0xFF,
0xDA,0x00,0x0C,0x03,0x01,0x00,0x02,0x10,0x03,0x10,0x00,0x00,0x01,0xBE,0x26,0x00,
0x00,0x3F,0xFF,0xC4,0x00,0x14,0x10,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xFF,0xDA,0x00,0x08,0x01,0x01,0x00,0x01,
0x05,0x02,0x1F,0xFF,0xC4,0x00,0x14,0x11,0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0xDA,0x00,0x08,0x01,0x03,0x01,
0x01,0x3F,0x01,0x1F,0xFF,0xC4,0x00,0x14,0x11,0x01,0x00,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0xDA,0x00,0x08,0x01,0x02,
0x01,0x01,0x3F,0x01,0x1F,0xFF,0xC4,0x00,0x14,0x10,0x01,0x00,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xFF,0xDA,0x00,0x08,0x01,
0x01,0x00,0x06,0x3F,0x02,0x1F,0xFF,0xC4,0x00,0x14,0x10,0x01,0x00,0x00,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,0xFF,0xDA,0x00,0x08,
0x01,0x01,0x00,0x01,0x3F,0x21,0x1F,0xFF,0xDA,0x00,0x0C,0x03,0x01,0x00,0x02,0x00,
0x03,0x00,0x00,0x00,0x10,0x04,0x10,0x41,0xFF,0xC4,0x00,0x14,0x11,0x01,0x00,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,0xDA,
0x00,0x08,0x01,0x03,0x01,0x01,0x3F,0x10,0x1F,0xFF,0xC4,0x00,0x14,0x11,0x01,0x00,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x20,0xFF,
0xDA,0x00,0x08,0x01,0x02,0x01,0x01,0x3F,0x10,0x1F,0xFF,0xC4,0x00,0x14,0x10,0x01,
0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x30,
0xFF,0xDA,0x00,0x08,0x01,0x01,0x00,0x01,0x3F,0x10,0x1F,0xFF,0xD9};


char  ZeroServ_ini[32768];

#include "ZeroServ.hhh"

struct s_thr {
    u_short port; // thread port
    u_long  addr;
    char inter[64];
    SOCKET l_sock; // listen socket
    HANDLE t_hndl;
   }g_thr[MAX_THR];

struct s_cfg { char *p[3]; int l[3]; } g_cfg[MAX_CFG];

int g_n=0, g_nthr=0;


DWORD WINAPI ZeroServ(LPVOID pp)
{
 FILE *f=0;
 time_t t;
 int i, j, n=0, port, remote, datalen, retempty;
 struct s_cfg *g;
 struct sockaddr_in sa;
 SOCKET l_sock, msgsock=INVALID_SOCKET;
 struct s_thr *ts=(struct s_thr*)pp;
 char *p, *q, *host, *ext, *type, *data, info[64], url[LENURL], buff[2*8192];

 if( ts==0 ) // Initialize or ReInitialize
   {
    buff[0]=0; getcwd(buff,sizeof(buff));
    chklog();
    if( g_nthr ){BkNReq=-1;sprintf(turl[nurl=(nurl+1)%NURL],"Loading file  %.*s\\ZeroServ.ini",sizeof(turl[0])-100,buff);}
    if( g_nthr && log ) fprintf(log,"# %s\n",turl[nurl]);

    for( i=0 ; i<g_nthr ; i++ )
         TerminateThread(g_thr[i].t_hndl,0);
    for( l_sock=0, i=0 ; i<g_nthr ; g_thr[i].l_sock=0, i++ )
     if( g_thr[i].l_sock!=l_sock )
         closesocket(l_sock=g_thr[i].l_sock);
    g_nthr=0;

    f=fopen("ZeroServ.ini","r");
    if(f==0 || (n=fread(ZeroServ_ini,1,sizeof(ZeroServ_ini)-1,f))==-1 )
      {
       sprintf(turl[nurl=(nurl+1)%NURL],"Error reading %.*s\\ZeroServ.ini! Run \"ZeroServ -debug 4\" to see defaults",sizeof(turl[0])-100,buff);
       if(debug&&log) fprintf(log,"# %s\n",turl[nurl]);
       n=sizeof(default_ini);
       if( n>sizeof(ZeroServ_ini)-1 ) n=sizeof(ZeroServ_ini)-1;
       for( i=0 ; i<n ; i++ ) ZeroServ_ini[i]=default_ini[i];
      }
    if(f)fclose(f);
    ZeroServ_ini[n]=0;
     
    for( g_n=0, p=ZeroServ_ini, q=ZeroServ_ini+n ; p<q && g_n<MAX_CFG ; p++ )
       {
        if(*p==' '||*p=='\t'||*p=='\r'||*p=='\n') continue;
        if(*p=='{'||*p>='A' && *p<='Z')
         for( g=g_cfg+g_n++, i=*p, j=0 ; j<3 ; j++ )
            {
             while(p<q&&(*p==' '||*p=='\t'||*p=='\r'))p++;
             if(i=='{'&&j==2&&*p=='\n')p++;  g->p[j]=p;
             if(i=='{'&&j==2) while(p<q&&(*p!='}'||*(p+1)!='#'))p++;else
             while(p<q&&(*p!=' '&&*p!='\t'&&*p!='\r'&&*p!='\n'))p++;g->l[j]=p-g->p[j];
            }
        while(p<q&&*p!='\n')p++;
       }
    for(i=0;i<g_n;i++)
       { g=g_cfg+i;
         for(j=0;j<3;j++)g-> p[j][g->l[j]]=0;
         if(debug==-1 && strcmp(g->p[0],"Debug")==0) debug=atoi(g->p[1]);
       }
    if(log==0) debug=0;
    if(debug>=4&&log)
      for(i=0;(g=g_cfg+i)!=0&&i<g_n;i++)
         fprintf(log,"%s\t%s\t%s%s\n",g->p[0],g->p[1],g->p[2],g->p[0][0]=='{'?"}#":"");

    for( i=0 ; i<g_n ; i++ )
     if( (g=g_cfg+i)->p[0][0]=='P') // Port
       {
        char ip[64];
        for(p=g->p[1],q=ip; *p!=':' && *p!=0 && q-ip<63; p++,q++) *q=*p; *q=0;
          if( *p==':' ) p++;
         port=atoi(p); n=atoi(g->p[2]);
    
         memset(&sa,0,sizeof(sa));
         sa.sin_family      = AF_INET;
         sa.sin_addr.s_addr = inet_addr(ip); 
         sa.sin_port        = htons(port);
    
         if( (l_sock=socket(AF_INET,SOCK_STREAM,0))==INVALID_SOCKET ||
              bind(l_sock,(struct sockaddr*)&sa,sizeof(sa))==SOCKET_ERROR ||
              listen(l_sock,SOMAXCONN)==SOCKET_ERROR )
            {if(log)fprintf(log,"# Error: bind/listen to \"%s\" failed with error %d.\n",g->p[1],WSAGetLastError());}
         else
           {
            if(debug&&log)fprintf(log,"# ZeroServ " Z_VERSION " (www.ranish.com) "
            	     "listening on %s (%d threads)\n",g->p[1],min(n,MAX_THR-g_nthr));
            for( j=0 ; j<n && g_nthr<MAX_THR ; j++, g_nthr++ )
               { DWORD Tid;
                g_thr[g_nthr].port=port;
                g_thr[g_nthr].addr=sa.sin_addr.s_addr;
                strncpy(g_thr[g_nthr].inter,g->p[1],sizeof(g_thr[g_nthr].inter));
                g_thr[g_nthr].l_sock=l_sock;
                g_thr[g_nthr].t_hndl=CreateThread(NULL,0,ZeroServ,&g_thr[g_nthr],0,&Tid);
               }
            }
        }
    if( debug<1 && log ) { fclose(log); log=NULL; }
    return 0;
   }

 while(1)
 {
  if( msgsock!=INVALID_SOCKET )
    {
     while(n>0)
        {
         n=send(msgsock,buff,n,0);
         if( f==0 || feof(f) || n==SOCKET_ERROR ) break;
         n=fread(buff,1,sizeof(buff),f);
        }
     closesocket(msgsock);
    }

  if( f!=0 ) fclose(f); f=0;

  n=sizeof(sa);
  if( (msgsock=accept(ts->l_sock,(struct sockaddr*)&sa,&n))==INVALID_SOCKET ||
      (n=recv(msgsock,buff,sizeof(buff),0))==SOCKET_ERROR ) continue; //WSAGetLastError()
  NReq++;
  time(&t);
  sprintf(info,"%.24s\t%s:%d",ctime(&t),inet_ntoa(sa.sin_addr),htons(sa.sin_port));
  remote=(sa.sin_addr.s_addr!=INADDR_LOOPBACK && sa.sin_addr.s_addr!=ts->addr?1:0);

  chklog();
  if(debug>=4&&log)fwrite(buff,1,n,log);

  if( strncmp(buff,"GET ",4)!=0 )
    { if(debug>=1&&log)fprintf(log,"%s\t%s:\"%.512s\"\tUnknown Request.\n",info+4,ts->inter,buff); continue; }
     
  host=q=url+sprintf(url,"%s:",ts->inter);
  port=0;
  for( p=buff ; p<buff+n-6 && (*p!='\n' || p[1]!='\n') ; p++ )
   if( *p=='\n' && strncmp(p,"\nHost:",6)==0 )
     {
      p+=6;
      while( p<buff+n &&(*p==' ' || *p=='\t') ) p++;
      while( p<buff+n && *p!=' ' && *p!='\t' && *p!='\r' && *p!='\n' &&
                         *p!='/' && *p!='\\' && *p!=0 && q<url+sizeof(url)-20 )
           { if(*p==':') port=1; *q=*p; p++; q++; }
      break;
     }

  p=buff+4;
  if( strncmp(p,"http://",7)==0 &&
     (q==host || strncmp(p+7,host,q-host)==0) ) p+=7+(q-host);
  if( *p!=':' && port==0 ) q+=sprintf(q,":%d",ts->port);
  if( *p!=':' && *p!='/' && *p!='\\' ) *(--p)='/';
  while( p<buff+n && *p!=' ' && *p!='\t' && *p!='\r' && *p!='\n' &&
                     *p!='?' && *p!=0 && q<url+sizeof(url)-20 )
     if( *(q-1)=='/' && p[0]=='.' && p[1]=='.' &&(p[2]=='/'||p[2]=='\\')) p+=3;
     else { if(*p=='\\') *q='/'; else *q=*p; p++; q++; }
  *q=0;

 n=0;
 buff[0]=0;
 
 for( i=0 ; remote && i<g_n ; i++ )
  if( (g=g_cfg+i)->p[0][0]=='A' )
    {
     u_long mask=inet_addr(g->p[2]);
     p=g->p[1]; q=url;
     do{if(*p=='*')for(p++;*q!=0&&*q!=*p;q++);}while(*p!=0&&*p++==*q++);
     if(*p==0&&(*q==0||*(q-1)==':'||*(q-1)=='/')&&
             (sa.sin_addr.s_addr&mask)==(ts->addr&mask) ) remote=0;
    }
 if( remote ) // remote host does not have acceess rights
   {
    if(debug>=1&&log) fprintf(log,"%s\t%s\tRejected.\n",info+4,url);
    sprintf(turl[nurl=(nurl+1)%NURL],"Rejected [%s] %s",info+4,url);
    continue;
   }
 
 if(debug>=3&&log)fprintf(log,">>> Requested: %s\n",url);
 
 for( i=0 ; i<g_n ; i++ ) // Find virtual server/url match
  if( (g=g_cfg+i)->p[0][0]=='S' )
    {
     p=g->p[1]; q=url;
     do{if(*p=='*')for(p++;*q!=0&&*q!=*p;q++);}while(*p!=0&&*p++==*q++);
     if(*p==0&&(*q==0||*(q-1)=='/'))
       {
        strcpy(buff,g->p[2]);
        if( buff[0]==0 || *q==0 ) break;
        sprintf(buff+g->l[2],"%s%s",buff[g->l[2]-1]=='/'?"":"/",q);
        break;
       }
    }

 if( strncmp(buff,"Error:",6)==0 ) // Error:301/http://some.other.site/path/
   {
    char tmp[LENURL];
    strncpy(tmp,buff,LENURL-1); tmp[LENURL-1]=0;
    n=sprintf(buff,
      "HTTP/1.1 %d Moved\n"
      "Connection: close\n"
      "Location: %s\n\n", atoi(tmp+6),tmp+10);
    if(debug>=2&&log)fprintf(log,"%s\t%s\t%s\n",info+4,url,tmp);
    continue;
   }

 if( buff[0]==0 ) // No server - try to match url
 for( i=0 ; i<g_n ; i++ )
  if( (g=g_cfg+i)->p[0][0]=='M' && strstr(url,g->p[1])!=0 )
    {
     strcpy(buff,g->p[2]);
     break;
    }

 data=0;
 if( buff[0]!=0 ) // See if file is in ZeroServ_ini
 for( i=0 ; i<g_n ; i++ )
  if( (g=g_cfg+i)->p[0][0]=='{' && strcmp(buff,g->p[1])==0 )
    { data=g->p[2]; datalen=g->l[2]; break; }

 ext="";//Determine file extension
 p=buff;
 if(*p==0 ) p=url;
 for(q=p;*p!=0;p++);
 if( p!=q && *(p-1)=='/' )
   { strcpy(p,"index.htm"); p+=5; }
 else while(p!=q&&*p!='.'&&*p!='/')p--;
 if(*p=='.') ext=p;

 type="application/octet-stream";
 for( i=0 ; i<g_n ; i++ )//Determine file type by extension
  if( (g=g_cfg+i)->p[0][0]=='T' && strcmp(ext,g->p[1])==0 )
    { type=g->p[2]; break; }

 if(debug>=4&&log)fprintf(log,"buff=\"%s\" ext=\"%s\" type=\"%s\" data=%p\n",buff,ext,type,data);

 retempty=0;
 if( data==0 )
 if( buff[0]==0 || buff[0]=='.' && buff[1]!='/' || (f=fopen(buff,"rb"))==0 )
   {
         if( strcmp(ext,".gif")==0 ) { data=(char*)gif20x20; datalen=sizeof(gif20x20); strcpy(buff,"[]"); }
    else if( strcmp(ext,".jpg")==0 ) { data=(char*)jpg20x20; datalen=sizeof(jpg20x20); strcpy(buff,"[]"); }
    else
      {
       if( strcmp(ext,".txt")!=0 &&
           strcmp(ext,".js" )!=0 ) type="text/html";
       data="\n";
       datalen=1;
       strcpy(buff,"[]");
      }
    retempty=1;
   }
 if(f)setbuf(f,0);

 if(debug>=3&&log) fprintf(log,"<<< Returning: [%s] %s\n",type,buff);
 if(debug>=1 && retempty==0 && strncmp(buff,"empty.",6)!=0 ||
    debug>=2&&log) fprintf(log,"%s\t%s\t%s\t%s\n",info+4,url,buff,type);

 sprintf(turl[nurl=(nurl+1)%NURL],"%s  >>> [%s] %s",url,type,buff);

 n=sprintf(buff,"HTTP/1.1 200 OK\n"
    "Connection: close\n"
    "Content-Type: %s\n\n",type);

 if( data )
   {
    memmove(buff+n,data,datalen);
    n+=datalen;
   }
 }
}
